//****************************************************************************
//TweenLiteSample
//@auther Masayuki Daijima
//****************************************************************************

package 
{
	import flash.display.*;
	
	//TweenLiteクラスをインポート
	import gs.*;
	import gs.easing.*;
	
	public class TweenLiteSample extends Sprite
	{
		private var _bg				:Sprite;
		private var _mask			:Sprite;
		
		//ステージの幅
		private var w				:uint = 300;
		
		//ステージの高さ
		private var h				:uint = 300;
		
		//マスク内の正方形の一辺の長さ
		private var px				:uint = 10;
		
		//横列の正方形の配置数
		private var wLen			:uint = w/px;
		
		//縦列の正方形の配置数
		private var hLen			:uint = h/px;
		
		private var pxHolder		:Array = [];
		
		public function TweenLiteSample():void 
		{
			stage.quality = StageQuality.HIGH;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			initialize();
		}
		
		private function initialize():void 
		{
			//背景をステージに配置
			_bg = new BG();
			addChild(_bg);
			
			createMask();
			show();
		}
		
		private function createMask():void 
		{
			//マスク用のSprite(_mask)を配置
			_mask = new Sprite();
			addChild(_mask);
			
			//_maskを_bgのマスクに設定
			_bg.mask = _mask;
			
			//_mask内に正方形を敷き詰める。
			for(var i:uint=0;i<=wLen;i++){
				for(var j=0;j<=hLen;j++){
					var sp = new Sprite();
					_mask.addChild(sp);
					sp.x = i*px;
					sp.y = j*px;
					createBox(sp);
					pxHolder.push(sp);
					sp.scaleX = sp.scaleY = 0;
				}
			}
		}
		
		//正方形を描画
		private function createBox(sp):void 
		{
			sp.graphics.beginFill(0xFF0000);
			sp.graphics.drawRect(0, 0, px, px);
			sp.graphics.endFill();
		}
		
		//背景を表示
		private function show():void 
		{
			var len:uint = pxHolder.length;
			//マスク内の正方形をトゥイーンで順番に拡大率100%にしています。
			for(var i:uint=0;i<len;i++){
				var sp:Sprite = pxHolder[i];
				if(i==pxHolder.length-1) TweenLite.to(sp, 0.3, {delay:i/5000+0.7, scaleX:1, scaleY:1, ease:Quad.easeInOut, onComplete:hide});
				else TweenLite.to(sp, 0.3, {delay:i/5000+0.7, scaleX:1, scaleY:1, ease:Sine.easeInOut});
			}
		}
		
		//背景を非表示
		private function hide():void 
		{
			var len:uint = pxHolder.length;
			//マスク内の正方形をトゥイーンで順番に拡大率0%にしています。
			for(var i:uint=0;i<len;i++){
				var sp:Sprite = pxHolder[i];
				if(i==pxHolder.length-1) TweenLite.to(sp, 0.3, {delay:i/5000+0.7, scaleX:0, scaleY:0, ease:Quad.easeInOut, onComplete:show});
				else TweenLite.to(sp, 0.3, {delay:i/5000+0.7, scaleX:0, scaleY:0, ease:Sine.easeInOut});
			}
		}
	}
}