//****************************************************************************
//Loading
//@auther Masayuki Daijima
//****************************************************************************

package 
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	
	public class Loading
	{
		private var _layer				:Sprite;
		
		private var loader1				:Loader;
		private var loader2				:Loader;
		private var loader3				:Loader;
		
		private var progressBar			:ProgressBar;
		private var path				:String = "images/";
		private var swfList				:Array = ["capture1.gif", "capture2.gif", "capture3.gif"];
		private var loadCnt				:uint;
		public var percent				:Number = 0;
		
		public function Loading(layer:Sprite):void 
		{
			_layer = layer;
		}
		
		public function start():void 
		{
			loadCnt = 0;
			
			//一枚目の画像を読み込む
			var req :URLRequest = new URLRequest(path+swfList[0]);
			loader1 = new Loader();
			loader1.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			loader1.contentLoaderInfo.addEventListener( Event.COMPLETE, onLoadComplete1 );
			loader1.load( req );
			
			//プログレスバーインスタンスを作成
			progressBar = new ProgressBar(this, _layer, _layer.stage.stageWidth);
			_layer.addChild(progressBar);
			
			//プログレスバーが100％になったら呼ばれるイベントを設定
			progressBar.addEventListener(ProgressBar.STRETCH, onStretchProgressBar);
			
			//プログレスバーの動作を実行
			progressBar.start();
		}
		
		private function onLoadProgress(event:ProgressEvent):void 
		{
			//ローディングの進捗を計算
			var per:Number = event.bytesLoaded/event.bytesTotal/swfList.length;
			percent = 1 / swfList.length * loadCnt + per;
		}
		
		private function onLoadComplete1(event:Event):void 
		{
			loadCnt++;
			loader1.contentLoaderInfo.removeEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			loader1.contentLoaderInfo.removeEventListener( Event.COMPLETE, onLoadComplete1 );
			
			//二枚目の画像を読み込む
			var req :URLRequest = new URLRequest(path+swfList[1]);
			loader2 = new Loader();
			loader2.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			loader2.contentLoaderInfo.addEventListener( Event.COMPLETE, onLoadComplete2 );
			
			loader2.load( req );
		}
		
		private function onLoadComplete2(event:Event):void 
		{
			loadCnt++;
			loader2.contentLoaderInfo.removeEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			loader2.contentLoaderInfo.removeEventListener( Event.COMPLETE, onLoadComplete2 );
			
			//三枚目の画像を読み込む
			var req :URLRequest = new URLRequest(path+swfList[2]);
			loader3 = new Loader();
			loader3.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			loader3.contentLoaderInfo.addEventListener( Event.COMPLETE, onLoadComplete3 );
			
			loader3.load( req );
		}
		
		private function onLoadComplete3(event:Event):void 
		{
			loadCnt++;
			loader3.contentLoaderInfo.removeEventListener( Event.COMPLETE, onLoadComplete3 );
		}
		
		private function onStretchProgressBar(event:Event):void {
			loader3.contentLoaderInfo.removeEventListener( ProgressEvent.PROGRESS, onLoadProgress );
			progressBar.removeEventListener( ProgressBar.STRETCH, onStretchProgressBar );
			
			//読み込んだ画像を表示
			loader1.content.x = 25;
			loader2.content.x = 350;
			loader3.content.x = 675;
			loader1.content.y = loader2.content.y = loader3.content.y = 25;
			
			_layer.addChild(loader1.content);
			_layer.addChild(loader2.content);
			_layer.addChild(loader3.content);
		}
	}
}