﻿//****************************************************************************
//ProgressBar
//@auther Masayuki Daijima
//****************************************************************************
package
{
	import flash.display.*;
	import flash.events.*;
	
	public class ProgressBar extends Sprite
	{
		public static const	STRETCH		:String = "stretch";
		
		private var _target				:Loading;
		private var _layer				:Sprite;
		private var _graphics			:Graphics;
		private var _width				:uint;
		private var _displayWidth		:Number;
		
		public function ProgressBar(target:Loading, layer:Sprite, width:uint)
		{
			_target = target;
			_layer = layer;
			_graphics = layer.graphics;
			_width = width;
			
			_displayWidth = 0;
		}
		
		public function start():void {
			this.addEventListener(Event.ENTER_FRAME, run);
		}
		
		private function run(event:Event = null):void
		{
			// 現在のプログレスバーの幅を算出します
			var w:Number = _width * _target.percent;
			
			// 表示用の幅を算出します
			// これは、プログレスバーがだんだん伸びるアニメーションを実現するために必要です
			_displayWidth += (w - _displayWidth) / 3;
			
			// プログレスバーを描画します
			_graphics.clear();
			_graphics.beginFill(0x000000);
			_graphics.drawRect(0, 0, _displayWidth, 350);
			_graphics.endFill();
			
			// プログレスバーが完全に伸びきっていたら終了します
			if (_displayWidth >= _width-0.001) {
				end();
			}
		}
		
		private function end():void {
			this.removeEventListener(Event.ENTER_FRAME, run);
			dispatchEvent(new Event(ProgressBar.STRETCH));
		}
	}
}