//****************************************************************************
//MainThread
//@auther Masayuki Daijima
//****************************************************************************

package 
{
	import flash.display.*;
	import flash.net.*;
	
	import org.libspark.thread.Thread;
	import org.libspark.thread.utils.*;
	import org.libspark.thread.threads.display.*;
	
	public class MainThread extends Thread
	{
		private var _layer				:Sprite;
		private var executor			:SerialExecutor;
		private var path				:String = "images/";
		private var imageList			:Array = ["capture1.gif", "capture2.gif", "capture3.gif"];
		private var positionList		:Array = [25, 350, 675];
		
		public function MainThread(layer:Sprite):void 
		{
			_layer = layer;
		}
		
		override protected function run():void
		{
			//複数のスレッドを順番に実行するスレッド
			executor = new SerialExecutor();
			
			//複数の進捗状況をひとつにまとめるスレッド
			var progress:MultiProgress = new MultiProgress();
			
			for(var i:uint=0;i<imageList.length;i++){
				//SerialExecutorにLoaderThreadを追加
				executor.addThread(new LoaderThread(new URLRequest(path+imageList[i])));
				
				//MultiProgressに各スレッドの進捗状況を追加
				progress.addProgress(IProgressNotifier(executor.getThreadAt(i)).progress, 1.0);
			}
			
			//プログレスバー用のスレッド
			var p_bar = new ProgressBarThread(progress, _layer.graphics, _layer.stage.stageWidth)
			p_bar.start();
			p_bar.join();
			
			// executorを開始
			executor.start();
			
			next(loadComplete);
		}
		
		private function loadComplete():void 
		{
			for(var i:uint=0;i<imageList.length;i++){
				var cont = LoaderThread(executor.getThreadAt(i)).loader.content;
				
				cont.x = positionList[i];
				cont.y = 25;
				_layer.addChild(cont);
			}
		}
	}
}